﻿using System;
using System.Data;

using System.Data.SqlClient;
using System.Configuration;
using System.Web;
using Sql.DataAccessLayer;
using System.Collections.Generic;
using System.Text;
using System.Web.Caching;
/// <summary>
/// Core Script to process different website configuration settings.
/// </summary>
public class ConfigurationBLL
{
    // Supported VSK 5.7 and later
  
	public ConfigurationBLL()
	{}

    public static void Update_Value(int id, string value)
    {
        SqlHelper.ExecuteNonQuery(Config.ConnectionString, CommandType.Text, "UPDATE configurations set value=@value where id=" + id, new SqlParameter("@value", value));
        // Refresh Application Stat Value
        //HttpContext.Current.Application["config_" + id] = value;
        string cache_key = "config_" + id;
        HttpContext.Current.Cache[cache_key] = value;
    }

    public static string Return_Value(int id)
    {
        // Implement Cache Approach To Store Configuration Values
        string cache_key = "config_" + id;
        if (HttpContext.Current.Cache[cache_key] == null)
            HttpContext.Current.Cache.Add(cache_key, Return_NoCache_Value(id), null, DateTime.Now.AddHours(6), TimeSpan.Zero, CacheItemPriority.High, null);

        return HttpContext.Current.Cache[cache_key.ToString()].ToString();
        // Implement Application State Approach To Store Configuration Values
        //if (HttpContext.Current.Application["config_" + id] == null)
        //    HttpContext.Current.Application["config_" + id]= SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT value from configurations where id=" + id + "").ToString();

        //return HttpContext.Current.Application["config_" + id].ToString();
    }

    public static string Return_NoCache_Value(int id)
    {
        return SqlHelper.ExecuteScalar(Config.ConnectionString, CommandType.Text, "SELECT value from configurations where id=" + id + "").ToString();
    }
}