﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;


/// <summary>
/// Video Table Definition / Structure Class
/// </summary>
public class Video_Struct
{
    public Video_Struct()
    { }

    long _videoid = 0;
    int _categoryid = 0;
    string _categoryname = "";
    string _categories = ""; // added in vsk 5.7 to store videos in multiple categories.
    string _username = "";
    string _title = "";
    string _description = "";
    string _tags = "";
    string _duration = "";
    int _views = 0;
    int _favorites = 0;
    int _total_rating = 0;
    int _comments = 0;
    int _responses = 0;
    double _ratings = 0;
    double _avg_rating = 0;
    string _videofilename = "";
    string _thumbfilename = "";
    string _originalvideofilename = "";
    int _isenabled = 0;
    int _isprivate = 0;
    int _iscomments = 0; // enable disable comments for video
    int _isratings = 0; // enable disable rating for video
    int _isresponse = 0;
    int _isfeatured = 0;
    long _response_videoid = 0;
    int _duration_sec = 0;
    int _ispublished = 1;
    int _isreviewed = 0;
    string _flv_url = "";
    string _org_url = "";
    string _thumb_url = "";
    int _errorcode = 0;
    int _isexternal = 0;
    string _embed_script = "";
    string _ipaddress = "";
    int _isadult = 0;
    int _type = 0; // video or audio
    DateTime _date_added = DateTime.Now;
    private int _liked = 0;
    private int _disliked = 0;
    // user related
    string _picturename = "none";
    int _video_state = 0; // total no of uploaded videos by user
    int _audio_state = 0; // total no of audio files uploaded by user
    string _youtubeid = "";
    int _downloads = 0;
    int _mode = 0;
    long _galleryid = 0;

    private string _authkey = "";

    // query related
    private string _order = "date_added desc";
    private int _month = 0;
    private int _year = 0;
    private int _filter = 0; // filter records by views
    private int _datefilter = 0; // filter records by date
    private int _searchtype = 0;
    private bool _iscache = false;
    private bool _loadliked = false;
    private bool _loadfavorites = false;
    private int _pagenumber = 1;
    private int _pagesize = 20;
    private string _term = "";
  

    public int Mode
    {
        set { _mode = value; }
        get { return _mode; }
    }
    double _contentlength = 0; // content length of media
    int _istagreviewed = 1;
    private string _language = "en";
    public string Language
    {
        set { _language = value; }
        get { return _language; }
    }
    public long VideoID
    {
        set { _videoid = value; }
        get { return _videoid; }
    }

    public int CategoryID
    {
        set { _categoryid = value; }
        get { return _categoryid; }
    }
    public string CategoryName
    {
        set { _categoryname = value; }
        get { return _categoryname; }
    }

    public string Categories
    {
        set { _categories = value; }
        get { return _categories; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }
    }

    public string Title
    {
        set { _title = value; }
        get { return _title; }
    }

    public string Description
    {
        set { _description = value; }
        get { return _description; }
    }

    public string Tags
    {
        set { _tags = value; }
        get { return _tags; }
    }

    public string Duration
    {
        set { _duration = value; }
        get { return _duration; }
    }

    public int Views
    {
        set { _views = value; }
        get { return _views; }
    }

    public int Favorites
    {
        set { _favorites = value; }
        get { return _favorites; }
    }
    public int Total_Rating
    {
        set { _total_rating = value; }
        get { return _total_rating; }
    }

    public int Comments
    {
        set { _comments = value; }
        get { return _comments; }
    }
    public int Responses
    {
        set { _responses = value; }
        get { return _responses; }
    }
    public double Ratings
    {
        set { _ratings = value; }
        get { return _ratings; }
    }

    public double Avg_Rating
    {
        set { _avg_rating = value; }
        get { return _avg_rating; }
    }

    public string VideoFileName
    {
        set { _videofilename = value; }
        get { return _videofilename; }
    }

    public string ThumbFileName
    {
        set { _thumbfilename = value; }
        get { return _thumbfilename; }
    }
    public string OriginalVideoFileName
    {
        set { _originalvideofilename = value; }
        get { return _originalvideofilename; }
    }

    public int isEnabled
    {
        set { _isenabled = value; }
        get { return _isenabled; }
    }
    public int isPrivate
    {
        set { _isprivate = value; }
        get { return _isprivate; }
    }
    public int isComments
    {
        set { _iscomments = value; }
        get { return _iscomments; }
    }

    public int isRatings
    {
        set { _isratings = value; }
        get { return _isratings; }
    }

    public int isResponse
    {
        set { _isresponse = value; }
        get { return _isresponse; }
    }

    public int isFeatured
    {
        set { _isfeatured = value; }
        get { return _isfeatured; }
    }
    public long Response_VideoID
    {
        set { _response_videoid = value; }
        get { return _response_videoid; }
    }

    public int Duration_Sec
    {
        set { _duration_sec = value; }
        get { return _duration_sec; }
    }

    public int isPublished
    {
        set { _ispublished = value; }
        get { return _ispublished; }
    }

    public int isReviewed
    {
        set { _isreviewed = value; }
        get { return _isreviewed; }
    }

    public string FLV_Url
    {
        set { _flv_url = value; }
        get { return _flv_url; }
    }

    public string Org_Url
    {
        set { _org_url = value; }
        get { return _org_url; }
    }

    public string Thumb_Url
    {
        set { _thumb_url = value; }
        get { return _thumb_url; }
    }
    public int ErrorCode
    {
        set { _errorcode = value; }
        get { return _errorcode; }
    }
    public DateTime Date_Added
    {
        set { _date_added = value; }
        get { return _date_added; }
    }

    public int isExternal
    {
        set { _isexternal = value; }
        get { return _isexternal; }
    }

    public string Embed_Script
    {
        set { _embed_script = value; }
        get { return _embed_script; }
    }

    public string IPAddress
    {
        set { _ipaddress = value; }
        get { return _ipaddress; }
    }

    public int isAdult
    {
        set { _isadult = value; }
        get { return _isadult; }
    }

    public string PictureName
    {
        set { _picturename = value; }
        get { return _picturename; }
    }

    public int Uploaded_Videos
    {
        set { _video_state = value; }
        get { return _video_state; }
    }

    public int Uploaded_Audio
    {
        set { _audio_state = value; }
        get { return _audio_state; }
    }

    public int Type
    {
        set { _type = value; }
        get { return _type; }
    }

    public int Liked
    {
        set { _liked = value; }
        get { return _liked; }
    }

    public int Disliked
    {
        set { _disliked = value; }
        get { return _disliked; }
    }

    public string YoutubeID
    {
        set { _youtubeid = value; }
        get { return _youtubeid; }
    }

    public double ContentLength
    {
        set { _contentlength = value; }
        get { return _contentlength; }
    }

    public int isTagsreViewed
    {
        set { _istagreviewed = value; }
        get { return _istagreviewed; }
    }

    public int Downloads
    {
        set { _downloads = value; }
        get { return _downloads; }
    }

    public long GalleryID
    {
        set { _galleryid = value; }
        get { return _galleryid; }
    }
    public string AuthKey
    {
        set { _authkey = value; }
        get { return _authkey; }
    }

    // query related
    public string Order
    {
        set { _order = value; }
        get { return _order; }
    }

    public int Month
    {
        set { _month = value; }
        get { return _month; }
    }

    public int Year
    {
        set { _year = value; }
        get { return _year; }
    }

    public int DateFilter
    {
        set { _datefilter = value; }
        get { return _datefilter; }
    }

    public int SearchType
    {
        set { _searchtype = value; }
        get { return _searchtype; }
    }

    public bool isCache
    {
        set { _iscache = value; }
        get { return _iscache; }
    }

    public bool LoadLiked
    {
        set { _loadliked = value; }
        get { return _loadliked; }
    }
    
    public bool LoadFavorites
    {
        set { _loadfavorites = value; }
        get { return _loadfavorites; }
    }

    public int Filter
    {
        set { _filter = value; }
        get { return _filter; }
    }

    public int PageNumber
    {
        set { _pagenumber = value; }
        get { return _pagenumber; }
    }

    public int PageSize
    {
        set { _pagesize = value; }
        get { return _pagesize; }
    }

    public string Term
    {
        set { _term = value; }
        get { return _term; }
    }
}
