﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.GData.YouTube;
using Google.GData.Extensions.MediaRss;
using Google.YouTube;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;


public partial class adm_sc_engine_youtube_standard_Process : System.Web.UI.Page
{
   
    private string ApplicationName = "";
    private string DeveloperID = "";

    private int NewUpdates = 0;
    private int Update_Counter = 0;
    YouTubeRequestSettings settings = null;
    YouTubeRequest req = null;
    private string _categoryid = "";
    private int _isapprove = 1;
    private string _username = "";
    private string _feedid = "";
    private string _ytcat = "";

    public string CategoryID
    {
        set { _categoryid = value; }
        get { return _categoryid; }
    }

    public int isApproved
    {
        set { _isapprove = value; }
        get { return _isapprove; }
    }

    public string UserName
    {
        set { _username = value; }
        get { return _username; }
    }

    public string FeedID
    {
        set { _feedid = value; }
        get { return _feedid; }
    }

    public string Yt_Cat
    {
        set { _ytcat = value; }
        get { return _ytcat; }
    }

    

    protected void Page_Load(object sender, EventArgs e)
    {
        ApplicationName = Site_Settings.Yt_Application_Name;
        DeveloperID = Site_Settings.Yt_Developer_Key;
        this.UserName = Site_Settings.Yt_UserName;
        settings = new YouTubeRequestSettings(ApplicationName, DeveloperID);
        req = new YouTubeRequest(settings);
        if (!Page.IsPostBack)
        {
            if (Request.Params["feedid"] != null)
            {
                this.FeedID = Request.Params["feedid"].ToString();
            }
            if (Request.Params["cid"] != null)
            {
                this.CategoryID = Request.Params["cid"].ToString();
            }
            if (Request.Params["ytcat"] != null)
            {
                this.Yt_Cat = Request.Params["ytcat"].ToString();
                if (this.Yt_Cat == "all")
                    this.Yt_Cat = "";
            }

            Process();
        }
    }

    private void Process()
    {
        
        string feedurl="http://gdata.youtube.com/feeds/api/standardfeeds/" + this.FeedID;
        if(this.Yt_Cat!="")
            feedurl =feedurl + "_" + this.Yt_Cat;

        int start_index = 1;
        int max_results = 25;
        string final_feed_url = "";
        Update_Counter = 1; // just to start while counter
        while (Update_Counter > 0)
        {
            Update_Counter =0;
            final_feed_url = feedurl + "?start-index=" + start_index + "&max-results=" + max_results;
            Feed<Video> videoFeed = req.Get<Video>(new Uri(final_feed_url));
            start_index = start_index + 25;
            ProcessVideoList(videoFeed);
        }

      
        result.InnerHtml = NewUpdates + " Updates Process Successfully";
        NewUpdates = 0;
    }

    private void ProcessVideoList(Feed<Video> feed)
    {
        foreach (Video entry in feed.Entries)
        {
            ProcessVideoEntry(entry);
        }
    }

    private void ProcessVideoEntry(Video video)
    {
        try
        {
            //StringBuilder str = new StringBuilder();

            //if (video.YouTubeEntry.Location != null)
            //{
            //    str.Append("Latitude: " + video.YouTubeEntry.Location.Latitude + "<br />");
            //    str.Append("Longitude: " + video.YouTubeEntry.Location.Longitude + "<br />");
            //}
            //if (video.Media != null && video.Media.Rating != null)
            //{
            //    str.Append("Restricted in: " + video.Media.Rating.Country + "<br />");
            //}
            string videoid = video.Id;
            if (videoid.Contains(":"))
            {
                videoid = videoid.Remove(0, videoid.LastIndexOf(":") + 1);
            }
            string video_watch_id = "/watch?v=" + videoid;
            if (!VideoBLL.Check_YOUTUBE_ID(video_watch_id))
            {
                if (!video.IsDraft)
                {
                    string title = video.Title;
                    string description = video.Description;
                    string tag_list = video.Keywords;
                    string thumburl = "";
                    ArrayList thumb_urls = new ArrayList();
                    foreach (MediaThumbnail thumbnail in video.Thumbnails)
                    {
                        thumb_urls.Add(thumbnail.Url);
                        // str.Append("\tThumbnail URL: " + thumbnail.Url + "<br />");
                        // str.Append("\tThumbnail time index: " + thumbnail.Time + "<br />");
                    }
                    if (thumb_urls.Count > 1)
                    {
                        int count = Convert.ToInt32(thumb_urls.Count / 2);
                        thumburl = thumb_urls[count].ToString();
                    }
                    else
                    {
                        thumburl = thumb_urls[0].ToString();
                    }
                    string duration_sec = "";
                    foreach (Google.GData.YouTube.MediaContent mediaContent in video.Contents)
                    {
                        // str.Append("\tMedia Location: " + mediaContent.Url + "<br />");
                        // str.Append("\tMedia Type: " + mediaContent.Format + "<br />");
                        duration_sec = mediaContent.Duration;
                    }
                    // process and add video
                    string flv_filename = "";
                    string original_filename = "";
                    string thumb_filename = "";
                    string duration = "";

                    // set video actions : 1 -> on, 0 -> off
                    int isenabled = 1;
                    int ispublished = 1;
                    int isreviewed = isApproved;
                    int isprivate = 0;
                    int isresponse = 0;
                    int isexternal = 1;
                    string flv_url = "none";
                    //string _embed = Generate_Embed_Script(videoid);
                    string _embed = videoid;
                    if (!Config.isAutomativeApproval())
                        isreviewed = 0;

                    string ipaddress = Request.ServerVariables["REMOTE_ADDR"].ToString();
                    string username = "";
                    username = this.UserName;

                    string _tags = tag_list.ToString();
                    if (_tags.Length > 200)
                        _tags = _tags.Substring(0, 200);

                    // remove <a tags from description
                    Regex _href = new Regex(@"<a[^<]+?>", RegexOptions.Singleline); // remove <a href.....>
                    Regex _hrefend = new Regex(@"</a>", RegexOptions.Singleline); // remove </a>
                    description = _href.Replace(description, string.Empty);
                    description = _hrefend.Replace(description, string.Empty);

                    string _des = description;
                    if (_des.Length > 2000)
                        _des = _des.Substring(0, 2000);

                    Regex _regext = new Regex("'", RegexOptions.Singleline);
                    _des = _regext.Replace(_des, "\'");
                    title = _regext.Replace(title, "\'");
                    _tags = _regext.Replace(_tags, "\'");
                    string _taglist = _regext.Replace(tag_list.ToString(), "\'");
                    int istagsreviewed = 1; // tags not reviewed yet
                    Video_Struct vd = new Video_Struct();
                    vd.CategoryID = 0; // store categoryname or term instead of category id
                    vd.Categories = CategoryID;
                    vd.UserName = username;
                    vd.Title = title;
                    vd.Description = _des;
                    vd.Tags = _tags;
                    vd.Duration = duration;
                    vd.Duration_Sec = Convert.ToInt32(duration_sec);
                    vd.OriginalVideoFileName = original_filename;
                    vd.VideoFileName = flv_filename;
                    vd.ThumbFileName = thumb_filename;
                    vd.isPrivate = isprivate;
                    vd.isEnabled = isenabled;
                    vd.Response_VideoID = 0;
                    vd.isResponse = isresponse;
                    vd.isPublished = ispublished;
                    vd.isReviewed = isreviewed;
                    vd.FLV_Url = flv_url;
                    vd.Thumb_Url = thumburl;
                    vd.Embed_Script = _embed;
                    vd.isExternal = isexternal;
                    vd.IPAddress = ipaddress;
                    vd.Type = 0;
                    vd.YoutubeID = video_watch_id;
                    vd.isTagsreViewed = istagsreviewed;
                    VideoBLL.Process_Info(vd, false);

                    NewUpdates++;
                    Update_Counter++;
                }
            }
           
        }
        catch (Exception ex)
        {
            result.InnerHtml = ex.Message;
        }
    }

    public string ReplaceHyphinWithPlus(string input)
    {
        string str = Regex.Replace(input, @"[\-]", "+");
        return str;
    }


}