﻿<%@ WebHandler Language="C#" Class="loaduservideos" %>

using System;
using System.Web;
using System.Text;
using System.Collections;
using System.Collections.Generic;

public class loaduservideos : IHttpHandler
{
    
    // This handler is used to load user videos
    private string UserName = "";
    private int PageNumber = 1;
    private int PageSize = 0;
    private int TotalVideos = 0; // total videos uploaded by user
    private int MediaType = 0; // 0: video, 1: audio
    private string Output = "";
    private string ElementID = "";

    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = "text/plain";
        if (context.Request.Params["usr"] != null)
            this.UserName = context.Request.Params["usr"];
        if (context.Request.Params["pno"] != null)
            this.PageNumber = Convert.ToInt32(context.Request.Params["pno"]);
        if (context.Request.Params["psize"] != null)
            this.PageSize = Convert.ToInt32(context.Request.Params["psize"]);
        if (context.Request.Params["vids"] != null)
            this.TotalVideos = Convert.ToInt32(context.Request.Params["vids"]);
        if (context.Request.Params["mtp"] != null)
            this.MediaType = Convert.ToInt32(context.Request.Params["mtp"]);
        if (context.Request.Params["elid"] != null)
            this.ElementID = context.Request.Params["elid"].ToString();

        if (this.UserName != "")
        {
            this.Output = Load_User_Videos();
        }

        context.Response.Write(this.Output);
    }

    // load comments
    private string Load_User_Videos()
    {
        string _mtitle = "videos";
        if (this.MediaType == 1)
        {
            _mtitle = "audio files";
        }
        
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        str.Append("<div class=\"ajax_out_box ui-corner-all\">");
        str.Append("<div class=\"row-fluid\">");
        str.Append("<div style=\"float:left; width:72%; padding-top:4px;\">");
        // user video link
        string user_video_url = "";
        if (MediaType == 0)
            user_video_url = Config.GetUrl() + "videos/uservideos.aspx?usr=" + this.UserName;
        else
            user_video_url = Config.GetUrl() + "audio/useraudio.aspx?usr=" + this.UserName;

        str.Append("<a href=\"" + user_video_url + "\" class=\"xmedium-text bold\">See all " + this.TotalVideos + " " + _mtitle + "</a>");
        str.Append("</div>");
        str.Append("<div style=\"float:right;width:22%;\">");
        // generate ajax pagination
        string path = Config.GetUrl() + "handlers/media/loaduservideos.ashx";
        string parameters = "mtp=" + this.MediaType + "&usr=" + this.UserName + "&psize=" + this.PageSize + "&vids=" + this.TotalVideos + "&elid=" + this.ElementID + "";
        str.Append(Pagination_Process.Ajax_Pagination_V2(this.TotalVideos, this.PageSize, this.PageNumber));
        str.Append("</div>");
        str.Append("</div>");

        // query
        Video_Struct query = new Video_Struct();
        query.Term = "";
        query.isFeatured = 2;
        query.Type = this.MediaType;
        query.UserName = this.UserName;
        query.isEnabled = 1;
        query.isReviewed = 1;
        query.isPrivate = 0;
        query.isAdult = 2;
        query.isExternal = 3;
        query.Order = "date_added desc, liked desc, views desc";
        query.PageSize = this.PageSize;
        query.PageNumber = this.PageNumber;
        VideoBLL vbll = new VideoBLL();
        List<Video_Struct> _list = vbll.Fetch_Videos_Limit(query);
        if (_list.Count > 0)
        {
            // load comments
            int i = 0;
            VideoItem video = new VideoItem();
            for (i = 0; i <= _list.Count - 1; i++)
            {
                // generate thumb rotator script for single video item                
                rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
                // single comment item
                video.ShowDate = false;
                video.ShowTitle = true;
                video.ShowAuthor = true;
                video.ShowViews = true;
                video.ShowDownloads = false;
                video.BoxWidth = 145;
                video.Width = 125;
                video.Height = 72;
                video.BoxSpace = 10;
                video.isAdmin = false;
                video.isHoverEffect = true;
                video.TitleLength = 0;
                video.ContentLayout = 0; // 0: contents on bottom, 1: contents on left;
                video.LeftWidth = 45; // % // works with contentlayout=1;
                video.RightWidth = 54; // % // works with contentlayout=1;
                video.Type = this.MediaType;
                video.UserCaption = "by";
                str.Append(video.Process(_list[i]));
                video.BreakLine = false;
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items

        }
        else
        {
            str.Append(Config.SetHiddenMessage_v2("No User Uploaded Videos","",true,0));
        }
        // append thumb rotator script
        str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>");
        str.Append("</div>");
        // return and display output on page generate by script here
        return str.ToString();
    }
    
    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}