﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_uservideos : System.Web.UI.Page
{
    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // process website layout
            Process_Layout();
            if (Request.Params["usr"] != null)
            {
                string UserName = Request.Params["usr"].ToString().Trim();
                string caption = "";
                string order = "";
                if (Request.Params["o"] != null)
                {
                    string index = Request.Params["o"].ToString();
                    caption = SetTabs(index);
                    order = "&o=" + index;
                }
                lst1.isListStatus = true;
                lst1.isListNav = true;
                lst1.UserName = UserName;
                lst1.SearchType = 0;
                lst1.ShowUser = false;
                lst1.PageTitle = UserName + "" + caption + " uploaded videos";
                lst1.PageDescription = "list of " + caption + " videos uploaded by " + UserName; //"Browse " + tagname.ToLower() + " best videos";
                lst1.NoRecordFoundText = "No videos uploaded by " + UserName; // "No " + tagname + " Videos Found!";
                lst1.isFeatured = 2; // load both featured and normal videos
                lst1.isAudio = 0; // load only videos
                lst1.isPrivate = 0; // load only public videos
                lst1.isCache = false;
                lst1.PageSize = Site_Settings.Video_Page_Size;

                // pagination urls
                lst1.DefaultUrl = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString() + "" + order;
                lst1.Pagination_Url = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString() + "&p=[p]" + "" + order;
                // top navigation urls
                lst1.Recent_Url = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString();
                lst1.MostViewed_Url = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString() + "&o=mv";
                lst1.MostFavorited_Url = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString() + "&o=mf";
                lst1.Toprated_Url = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString() + "&o=tr";
                lst1.MostCommented_Url = "videos/uservideos.aspx?usr=" + Request.Params["usr"].ToString() + "&o=mc";

                set_bread_links(UserName + "" + caption + " videos");
            }
            else
            {
                Response.Redirect(Config.GetUrl("videos/"));
            }
        }
    }

    private string SetTabs(string index)
    {
        string caption = "";
        lst1.Order = "v.date_added desc, v.liked desc, v.views desc";
        switch (index)
        {
            case "mc":
                caption= " most commented";
                lst1.Order = "v.comments desc, v.liked desc, v.views desc";
                lst1.TabIndex = 4;
                break;
            case "mf":
                caption = " most favorited";
                lst1.Order = "v.favorites desc, v.liked desc, v.views desc";
                lst1.TabIndex = 2;
                break;
            case "mv":
                caption = " most viewed";
                lst1.Order = "v.views desc, v.liked desc";
                lst1.TabIndex = 1;
                break;
            case "tr":
                caption = " top rated";
                lst1.Order = "v.liked desc, v.views desc";
                lst1.TabIndex = 3;
                break;
        }
        return caption;
    }

    private void set_bread_links(string categoryname)
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">" + Resources.vsk.videos + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">" + lst1.PageTitle + "</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;

            tg.Visible = false; // show only on three column layout
        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}